function [u z] = BC_DynGrid(t,x)

%**************************************************************************
% The MatMol Group (2009)
% Function....... : Separate the dependent variables and introduce the
%                   boundary conditions for the Buckley-Leverett example
% Input...........: t: current time
%                   x: current differential values
%**************************************************************************

global n ne zL zR

% Separate dependent variables and node positions
for j=1:ne,
    u(2:n+1,j) = x(j:ne+1:n*(ne+1));
end
z = [zL x(ne+1:ne+1:n*(ne+1))' zR];

% Implement the BCs
u(1,1)   = 1 ;
u(n+2,1) = 0 ;

end % End of function BC_DynGrid
%**************************************************************************