%... %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%... % compute the sparsity of the Jacobian %
%... %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%...
%... The MatMol Group (2009)
%...
%... The sparsity of the jacobian is PDEs-depending ; anyhow the sparsity
%...
%... matrix Js is a nxn square-blocks matrix ; the dimension of each block is (ne+1)x(ne+1).
%...
%... So the global dimension of Js is (ne+1)xn.
%...
%...
     function jacob_sparse = JPat
     
     global n ne X eq choice
%...
     nt=ne+1;
%...
%... partie conditionne par le choix des diff. finies
%...
     for k=1:ne
         for i=1:n
             for j=1:ne
                 ibeg=max(0,i-1+eq(j,1,k));
                 if ibeg == 0
                     iend=eq(j,2,k)-eq(j,1,k);
                 else
                     iend=min(n-1,i-1+eq(j,2,k));
                 end
                 if iend == n-1
                     ibeg=iend-(eq(j,2,k)-eq(j,1,k));
                 end
                 X((i-1)*nt+k,ibeg*nt+j:nt:iend*nt+j)=eq(j,3,k);
                 X((i-1)*nt+k,(ibeg+1)*nt:nt:(iend+1)*nt)=eq(k,3,k);
             end
         end
     end
%
%... partie conditionne par le choix du moniteur
%...
     switch choice
         
       case('der1-1')
         for i=1:2
             X(i*nt,1:3*nt)=1;
             X(i*nt,4*nt)=1;
             X(i*nt,5*nt)=1;
         end
         for i=3:n-2
             X(i*nt,(i-2)*nt:nt:(i+2)*nt)=1;
             for k=1:ne
                 X(i*nt,(i-2)*nt+k:nt:i*nt+k)=1;
             end
         end
         for i=n-1:n
             X(i*nt,(n-3)*nt+1:n*nt)=1;
             X(i*nt,(n-3)*nt)=1;
             X(i*nt,(n-4)*nt)=1;
         end
         
       case('der1-2')
         for i=1:2
             X(i*nt,1:3*nt)=1;
             X(i*nt,4*nt)=1;
             X(i*nt,5*nt)=1;
         end
         for i=3:n-2
             X(i*nt,(i-2)*nt:nt:(i+2)*nt)=1;
             for k=1:ne
                 X(i*nt,(i-2)*nt+k:nt:i*nt+k)=1;
             end
         end
         for i=n-1:n
             X(i*nt,(n-3)*nt+1:n*nt)=1;
             X(i*nt,(n-3)*nt)=1;
             X(i*nt,(n-4)*nt)=1;
         end
         
       case('der1-3')
         X(nt,1:5*nt)=1;
         X(2*nt,1:5*nt)=1;
         for i=3:n-2
             X(i*nt,(i-3)*nt+1:(i+2)*nt)=1;
         end
         X((n-1)*nt,(n-5)*nt+1:n*nt)=1;
         X(n*nt,(n-5)*nt+1:n*nt)=1;
         
       case('der1-4')
         X(nt,1:5*nt)=1;
         X(2*nt,1:5*nt)=1;
         for i=3:n-2
             X(i*nt,(i-3)*nt+1:(i+2)*nt)=1;
         end
         X((n-1)*nt,(n-5)*nt+1:n*nt)=1;
         X(n*nt,(n-5)*nt+1:n*nt)=1;
         
       case('der1-5')
         for i=1:3
             X(i*nt,1:5*nt)=1;
         end
         for i=4:n-2
             X(i*nt,(i-4)*nt+1:(i+1)*nt)=1;
             X(i*nt,(i+2)*nt)=1;
         end
         X((n-1)*nt,(n-5)*nt+1:n*nt)=1;
         X(n*nt,(n-5)*nt+1:n*nt)=1;
         
       case('der1-6')
         for i=1:3
             X(i*nt,1:5*nt)=1;
         end
         for i=4:n-2
             X(i*nt,(i-4)*nt+1:(i+1)*nt)=1;
             X(i*nt,(i+2)*nt)=1;
         end
         X((n-1)*nt,(n-5)*nt+1:n*nt)=1;
         X(n*nt,(n-5)*nt+1:n*nt)=1;

       case('der2-1')
         for i=1:2
             X(i*nt,1:5*nt)=1;
         end
         for i=3:n-2
             X(i*nt,(i-3)*nt+1:(i+2)*nt)=1;
         end
         for i=n-1:n
             X(i*nt,(n-5)*nt+1:n*nt)=1;
         end

       case('der2-2')
         for i=1:2
             X(i*nt,1:5*nt)=1;
         end
         for i=3:n-2
             X(i*nt,(i-3)*nt+1:(i+2)*nt)=1;
         end
         for i=n-1:n
             X(i*nt,(n-5)*nt+1:n*nt)=1;
         end

       case('der2-3')
         for i=1:3
             X(i*nt,1:6*nt)=1;
         end
         for i=4:n-2
             X(i*nt,(i-4)*nt+1:(i+2)*nt)=1;
         end
         for i=n-1:n
             X(i*nt,(n-6)*nt+1:n*nt)=1;
         end

       case('der2-4')
         for i=1:3
             X(i*nt,1:6*nt)=1;
         end
         for i=4:n-2
             X(i*nt,(i-4)*nt+1:(i+2)*nt)=1;
         end
         for i=n-1:n
             X(i*nt,(n-6)*nt+1:n*nt)=1;
         end

       case('derfl1-1')
         for i=1:2
             X(i*nt,1:3*nt)=1;
             X(i*nt,4*nt)=1;
             X(i*nt,5*nt)=1;
         end
         for i=3:n-2
             X(i*nt,(i-2)*nt:nt:(i+2)*nt)=1;
             for k=1:ne
                 X(i*nt,(i-2)*nt+k:nt:i*nt+k)=1;
             end
         end
         for i=n-1:n
             X(i*nt,(n-3)*nt+1:n*nt)=1;
             X(i*nt,(n-3)*nt)=1;
             X(i*nt,(n-4)*nt)=1;
         end

       case('derfl1-2')
         for i=1:2
             X(i*nt,1:3*nt)=1;
             X(i*nt,4*nt)=1;
             X(i*nt,5*nt)=1;
         end
         for i=3:n-2
             X(i*nt,(i-2)*nt:nt:(i+2)*nt)=1;
             for k=1:ne
                 X(i*nt,(i-2)*nt+k:nt:i*nt+k)=1;
             end
         end
         for i=n-1:n
             X(i*nt,(n-3)*nt+1:n*nt)=1;
             X(i*nt,(n-3)*nt)=1;
             X(i*nt,(n-4)*nt)=1;
         end

       case('derfl1-3')
         X(nt,1:5*nt)=1;
         X(2*nt,1:5*nt)=1;
         for i=3:n-2
             X(i*nt,(i-3)*nt+1:(i+2)*nt)=1;
         end
         X((n-1)*nt,(n-5)*nt+1:n*nt)=1;
         X(n*nt,(n-5)*nt+1:n*nt)=1;
         
       case('der1-4')
         X(nt,1:5*nt)=1;
         X(2*nt,1:5*nt)=1;
         for i=3:n-2
             X(i*nt,(i-3)*nt+1:(i+2)*nt)=1;
         end
         X((n-1)*nt,(n-5)*nt+1:n*nt)=1;
         X(n*nt,(n-5)*nt+1:n*nt)=1;
         
       case('derfl2-1')
         for i=1:2
             X(i*nt,1:5*nt)=1;
         end
         for i=3:n-2
             X(i*nt,(i-3)*nt+1:(i+2)*nt)=1;
         end
         for i=n-1:n
             X(i*nt,(n-5)*nt+1:n*nt)=1;
         end

     end
     jacob_sparse=sparse(X);
